#include "micmanager.h"

MicManager::MicManager(short bufferSizeMatrix, int totalBufferSize, long int sampleFreq) {
    

    buffer = (short *) malloc(bufferSizeMatrix<<1);
    total_buffer = (short *) malloc(totalBufferSize<<1);

    buffer_size = bufferSizeMatrix;
    total_buffer_size = totalBufferSize;
    sample_rate = sampleFreq;

    openDev();
    setDev(sample_rate);
}

void MicManager::readBuffer(){ 
    frames = snd_pcm_readi(handle_capture, buffer, buffer_size);
    populateTotalBuffer();
}

void MicManager::populateTotalBuffer(){
    for(int i = 0; i < buffer_size; i++){
        total_buffer[index] = buffer[i];
        index = (index+1)%total_buffer_size;
    }
}

short *MicManager::getBuffer(){
    return buffer;
}

short *MicManager::getTotalBuffer(){
    return total_buffer;
}

void MicManager::closeDev(){
    snd_pcm_close(handle_capture);
}

void MicManager::openDev(){
    err_code = snd_pcm_open(&handle_capture, device, SND_PCM_STREAM_CAPTURE, 0);

    if(err_code < 0) {
        std::cout << "Capture open error: " << snd_strerror(err_code)<< std::endl;
        exit(EXIT_FAILURE);
    }
}
void MicManager::setDev(int sr){

    err_code = snd_pcm_set_params(handle_capture,
                             SND_PCM_FORMAT_S16_LE,
                             SND_PCM_ACCESS_RW_INTERLEAVED,
                             1,
                             sr,
                             1,
                             50);
    if(err_code < 0) {
        printf("Capture open error: %s\n", snd_strerror(err_code));
        exit(EXIT_FAILURE);
    }
}

void MicManager::setBufferSize(int size){

    //buffer_size = size;
    //short *c_buffer = (short *) realloc(buffer, buffer_size);
    //free(buffer);
    //buffer = c_buffer;
    //setDev(sample_rate);
}


